//+------------------------------------------------------------------+
//|                                                       MA-MTF.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot MA
#property indicator_label1  "MA"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

input int            InpPeriod=14;
input ENUM_TIMEFRAMES InpTimeframe=PERIOD_H4;

//--- indicator buffers
double         MABuffer[];

ENUM_TIMEFRAMES TimeFrame;

int handle=-1;
static int counter=0;
string indName;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,MABuffer,INDICATOR_DATA);
   ArraySetAsSeries(MABuffer,true);

   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);

   TimeFrame=InpTimeframe>Period() ? InpTimeframe : Period();
   handle=iMA(Symbol(),TimeFrame,InpPeriod,0,MODE_SMA,PRICE_OPEN);
   if(handle==-1)
     {
      Print("Create iMA handle failed. Error code:",GetLastError());
      return(INIT_FAILED);
     }

   string tfs=EnumToString(TimeFrame);
   indName=StringFormat("%s (%s, %d) ",MQLInfoString(MQL_PROGRAM_NAME),tfs,InpPeriod)+" ChartID="+(string)ChartID();
   Comment(indName);
   Print(indName,":"__FUNCTION__);
//---
   return(INIT_SUCCEEDED);
  }
void OnDeinit(const int reason) {  Comment("");  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   int maxBars=iBars(Symbol(),TimeFrame);
   if(counter<=2)Print("indName=",indName,"  counter=",++counter,"  prev_calc=",prev_calculated," maxBars=",maxBars);
   
   if(rates_total<=InpPeriod)return(0);

   ArraySetAsSeries(time,true);

   if(counter==1)ChartSetSymbolPeriod(0,NULL,0);
//---
   double tmp[1]={0};
   for(int i=0;i<1000 && i<rates_total;i++)
     {
      MABuffer[i]=0;
      int shift=iBarShift(Symbol(),TimeFrame,time[i]);
      if(shift>=maxBars-InpPeriod)break;
      if(CopyBuffer(handle,0,shift,1,tmp)==1)
        {
         MABuffer[i]=tmp[0];
        }
      else if(i<3)
        {
         Print("indName=",indName," i=",i,"  prev_calc=",prev_calculated,"   Error=",GetLastError());//...Error = 4806           
        }
     }

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
